#include<iostream>
#include<cmath>
#include<iomanip>
#include<limits>

using namespace std;

double f(double x)
{
	return x*x - 4*sin(x);
}

double bisection(double a, double b, double tol)
{
	//cout<<"a \t\t f(a) \t\t b \t\t f(b) \t\t m \t\t f(m)"<<endl;
	
	
		double m = ( a + b ) / 2;
		double fx = f( m );
		double fa = f( a );
		double fb = f( b );
		//cout<<setprecision(7)<<showpoint<<a<<"\t"<<fa<<"\t"<<b<<"\t"<<fb<<"\t"<<m<<"\t"<<fx<<"\n";
		if ( fabs( fx ) < tol ) 
			return m;
		if ( fa * fx < 0 ) {
			b = m;
			
		}
		else {	
			a = m;
			
		}
		return bisection(a,b,tol);
	
	return std::numeric_limits<double>::quiet_NaN();	//returns NaN when no solution is reached
}

int main(){
	cout<<"The solution is: "<<bisection(1,30,1e-5);
	system("pause");
	return 0;}