#include<iostream>
#include<cmath>
#include<iomanip>
#include<limits>

using namespace std;

double f(double x)
{
	return x*x - 4*sin(x);
}

double secant2(double x1, double x0, double tol)
{
	//cout<<"x1 \t\t f(x1) \t\t x0 \t\t f(x0) \t\t x \t\t f(x)"<<endl;
	
	
		double fx1 = f( x1 );
		double fx0 = f( x0 );
		double x = x1 - fx1*( x1 - x0 ) / ( fx1 - fx0 );
		double fx =  f(x);
		//cout<<setprecision(7)<<showpoint<<x1<<"\t"<<fx1<<"\t"<<x0<<"\t"<<fx0<<"\t"<<x<<"\t"<<fx<<"\n";
		if ( fabs( fx ) < tol ) 
			return x;
		return secant2(x,x1,tol);
		
	
	return std::numeric_limits<double>::quiet_NaN();	//returns NaN when no solution is reached
}



int main()
{
	
	cout<<"The solution is: "<<secant2(1,3,1e-5);
	
	return 0;
}




   
   
